#include "board.h"
#include "clock_config.h"
#include "peripherals.h"
#include "pin_mux.h"

/* DebugConsole */
#include "fsl_debug_console.h"

/* LCD */
#include "epd-spi/panel/lcd_zjy350c4001.h"

void      lcd_impl_init(void);
epd_ret_t lcd_impl_write_cmd(void *handle, uint8_t *cmd, uint32_t len);
epd_ret_t lcd_impl_write_data(void *handle, uint8_t *data, uint32_t len);
epd_ret_t lcd_impl_reset(void *handle);

static lcd_zjy350c4001_t s_lcd = {
    .user_data = NULL,
    .config =
        {
            .direction = LCD_ZJY350C4001_DIR_0,
            .pix_fmt   = LCD_ZJY350C4001_RGB565,
            .bgr_mode  = 1,
            .inversion = 1,
        },
    .cb =
        {
            .backlight_cb     = NULL,
            .write_command_cb = lcd_impl_write_cmd,
            .write_data_cb    = lcd_impl_write_data,
            .reset_cb         = lcd_impl_reset,
        },
};

int main(void) {
    BOARD_InitBootPins();
    BOARD_BootClockFROHF96M();
    BOARD_InitBootPeripherals();

    BOARD_InitDebugConsole();

    PRINTF("Hello world!!\r\n");

    lcd_impl_init();

    lcd_zjy350c4001_init(&s_lcd);

    for (;;) {
        __WFI();
    }
}